extern sfr sbit NS73M_LATCH_PIN;
extern sfr sbit NS73M_DATA_PIN;
extern sfr sbit NS73M_CLOCK_PIN;

extern sfr sbit NS73M_LATCH_PIN_DIRECTION;
extern sfr sbit NS73M_DATA_PIN_DIRECTION;
extern sfr sbit NS73M_CLOCK_PIN_DIRECTION;


void __NS73M_SEND(char Address, char Data)
{
char x;
NS73M_LATCH_PIN=0;

for(x = 0 ; x < 4 ; x++)
{
NS73M_CLOCK_PIN=0;
delay_us(1);
NS73M_DATA_PIN = Address.f0;
NS73M_CLOCK_PIN=1;
delay_us(1);
Address=Address>>1;
}

for(x = 0 ; x < 8 ; x++)
{
NS73M_CLOCK_PIN=0;
delay_us(1);
NS73M_DATA_PIN = Data.f0;
NS73M_CLOCK_PIN=1;
delay_us(1);
Data = Data>>1;
}

NS73M_LATCH_PIN=1;
Delay_ms(1);

NS73M_LATCH_PIN=0;
}


void FM_DISABLE()
{
   __NS73M_SEND(0x00, 0B10100000);
}
void FM_ENABLE()
{
  __NS73M_SEND(0x00, 0B10100001);
}

void FM_SET_FREQUENCY(float FREQUENCY)
{
  unsigned int Fr;

  if (FREQUENCY < 88.5) {
    __NS73M_SEND(0x08, 0B00011011);
  }
  else if (FREQUENCY < 97.9) {
    __NS73M_SEND(0x08, 0B00011010);
  }
  else if (FREQUENCY < 103.0) {
    __NS73M_SEND(0x08, 0B00011001);
  }
  else {
    __NS73M_SEND(0x08, 0B00011000);
  }

  Fr = (unsigned int) ((FREQUENCY + 0.304) / 0.008192);
  __NS73M_SEND(0x03,(char)(Fr&0x00ff));
  __NS73M_SEND(0x04, (char)((Fr&0xff00)>>8));
  __NS73M_SEND(0x0E, 0B00000101);
}


void FM_INIT(float FREQUENCY)
{
  NS73M_CLOCK_PIN=0;
  NS73M_DATA_PIN=0;
  NS73M_LATCH_PIN=0;
  NS73M_DATA_PIN_DIRECTION=0;
  NS73M_LATCH_PIN_DIRECTION=0;
  NS73M_CLOCK_PIN_DIRECTION=0;

  delay_ms(500);

  __NS73M_SEND(0x0E, 0B00000101);

  __NS73M_SEND(0x01, 0B10110100);

  __NS73M_SEND(0x02, 0B00000011);

  FM_SET_FREQUENCY(FREQUENCY);

  FM_ENABLE();

  __NS73M_SEND(0x0E, 0B00000101);

  __NS73M_SEND(0x06, 0B00011110);
}