/*
*****************************************************************
Library Name        : Strings Utility Library 

Release Date        : 3/10/2010

Library Author      : Nart Schinackow (c)

Library Version     : V.1.0

Programing Language : C

Notes               : Nothing
*****************************************************************
*/
void StringCopy(char* To, char* From)
{
        while(*To++=*From++);
}

void StringConcat(char* String, char* Add)
{
        while(*++String);
        while(*String++=*Add++);
}

unsigned int StringLength(char* String)
{
        unsigned int __c__;
        for(__c__=0;*String;String++)__c__++;
        return __c__;
}

/* Modified below
char* ConvertInt2String(unsigned int Value)
{
        unsigned int __t__;
        char* __p__;
        __t__=Value;
        for(__p__=__BUFFER__;__t__>0;__t__/=10)__p__++;
        for(*__p__='\0';Value>0;Value/=10)*--__p__=(Value%10)+48;
        return __p__=__BUFFER__;
}
*/


char* ConvertInt2String(unsigned int Value)
{
        unsigned int __t__;
        char* __p__;
    
        if(!Value)
        {
          __BUFFER__[0]='0';
          __BUFFER__[1]='\0';
        }
        else
        {
                __t__=Value;
                for(__p__=__BUFFER__;__t__>0;__t__/=10)__p__++;
                for(*__p__='\0';Value>0;Value/=10)*--__p__=(Value%10)+48;
        }
        return __p__=__BUFFER__;
}



unsigned int ConvertString2Int(char* String)
{
        unsigned int __c__;
        unsigned int __i__;
        unsigned int __s__;
        unsigned int __m__;
        for(__c__=0;*String;String++)__c__++;__s__=0;__m__=1;
        for(__i__=0;__i__<__c__;__i__++){__s__+=(*--String-48)*__m__;__m__*=10;}
        return __s__;
}


char* ConvertLong2String(unsigned long Value)
{
        unsigned long __t__;
        char* __p__;
    
        if(!Value)
        {
          __LONG__BUFFER__[0]='0';
          __LONG__BUFFER__[1]='\0';
        }
        else
        {
                __t__=Value;
                for(__p__=__LONG__BUFFER__;__t__>0;__t__/=10)__p__++;
                for(*__p__='\0';Value>0;Value/=10)*--__p__=(Value%10)+48;
        }
        return __p__=__LONG__BUFFER__;
}



unsigned long ConvertString2Long(char* String)
{
        unsigned int __c__;
        unsigned int __i__;
        unsigned long __s__;
        unsigned long __m__;
        for(__c__=0;*String;String++)__c__++;__s__=0;__m__=1;
        for(__i__=0;__i__<__c__;__i__++){__s__+=(*--String-48)*__m__;__m__*=10;}
        return __s__;
}

unsigned char* ConvertByte2BString(unsigned char Byte)
{
	unsigned char i;
	__Byte__Buffer__[8]='\0';
	for(i=7;i>0;i--)
	{
		__Byte__Buffer__[i]=(Byte%2)+48;
		Byte/=2;
	}
	__Byte__Buffer__[i]=(Byte%2)+48;
	return __Byte__Buffer__;  
}

unsigned char* ConvertWord2BString(unsigned int Word)
{
	unsigned char i;
	__Word__Buffer__[16]='\0';
	for(i=15;i>0;i--)
	{
		__Word__Buffer__[i]=(Word%2)+48;
		Word/=2;
	}
	__Word__Buffer__[i]=(Word%2)+48;
	return __Word__Buffer__;  
}


unsigned char ConvertBStringToByte(char* ByteString)
{
	unsigned char Offset,i,sum;
	for(i=7,Offset=1,sum=0;i>0;i--)
	{
		sum+=(ByteString[i]-48)*Offset;
		Offset*=2;
	}
	sum+=(ByteString[i]-48)*128;
	return sum;
}

unsigned int ConvertBStringToWord(char* WordString)
{
	unsigned char i;
	unsigned int sum,Offset;
	for(i=15,Offset=1,sum=0;i>0;i--)
	{
		sum+=(WordString[i]-48)*Offset;
		Offset*=2;
	}
	sum+=(WordString[i]-48)*32768;
	return sum;
}





char* ConvertByte2String(unsigned char Value)
{
        unsigned char __t__;
        char* __p__;
    
        if(!Value)
        {
          __BUFFER__[0]='0';
          __BUFFER__[1]='\0';
        }
        else
        {
                __t__=Value;
                for(__p__=__BUFFER__;__t__>0;__t__/=10)__p__++;
                for(*__p__='\0';Value>0;Value/=10)*--__p__=(Value%10)+48;
        }
        return __p__=__BUFFER__;
}



unsigned char ConvertString2Byte(char* String)
{
        unsigned char __c__;
        unsigned char __i__;
        unsigned char __s__;
        unsigned char __m__;
        for(__c__=0;*String;String++)__c__++;__s__=0;__m__=1;
        for(__i__=0;__i__<__c__;__i__++){__s__+=(*--String-48)*__m__;__m__*=10;}
        return __s__;
}




unsigned short StringCompare(char* StringA, char* StringB)
{
        unsigned int __l1__;
        unsigned int __l2__;
        __l1__=StringLength(StringA);
        __l2__=StringLength(StringB);
        if(__l1__!=__l2__)return 0;
        for(__l1__=0;*StringB;StringB++)if(*StringA++!=*StringB)return 0;
        return 1;
}


void StringReplace(char* x, char* y)
{
        while(*y)*x++=*y++;
}

unsigned short StringNCompare(char* Str1, char* Str2, unsigned int Number)
{
        while(Number>0)
        {
                if(*Str1++!=*Str2++)return 0;
                Number--;
        }
        return 1;
}


void StringNCopy(char* To, char* From, unsigned int Number)
{
        while(Number--!=0)
                *To++=*From++;
}

void StringToUpper(char* Str)
{
	while(*Str)
	{
		if(*Str>='a'&&*Str<='z')
			*Str-=' ';
		++Str;
	}
}

void StringToLower(char* Str)
{
	while(*Str)
	{
		if(*Str>='A'&&*Str<='Z')
			*Str+=' ';
		++Str;
	}
}

unsigned char IsCharUpper(char c)
{
	return (unsigned char)(c>='A'&&c<='Z');
}

unsigned char IsCharLower(char c)
{
	return (unsigned char)(c>='a'&&c<='z');
}

void ConvertFloatToString(float NUMBER, unsigned short PRECISION, char* OutBuffer)
{
	unsigned short i;
	unsigned int MUL,decimal,Fraction;
	char* p;
	for(i=0,MUL=1;i<PRECISION;i++)MUL*=10;
	decimal = (unsigned int)NUMBER;
    Fraction = ((unsigned int)(NUMBER*MUL)%MUL);
	for(p=OutBuffer,MUL=decimal;MUL>0;MUL/=10)++p;
	for(MUL=Fraction,*p++='.';MUL>0;MUL/=10)++p;*p='\0';
	for(--p;Fraction>0;Fraction/=10,p--)*p=(Fraction%10)+48;
	for(--p;decimal>0;decimal/=10,p--)*p=(decimal%10)+48;
}
