#include "Libraries/String.h"
#include "Libraries/Stdio.h"
#include "Libraries/NS73M.h"


sfr sbit NS73M_LATCH_PIN at RD1_bit;
sfr sbit NS73M_DATA_PIN at RD2_bit;
sfr sbit NS73M_CLOCK_PIN at RD3_bit;

sfr sbit NS73M_LATCH_PIN_DIRECTION at TRISD1_bit;
sfr sbit NS73M_DATA_PIN_DIRECTION at TRISD2_bit;
sfr sbit NS73M_CLOCK_PIN_DIRECTION at TRISD3_bit;


sbit LCD_RS at RE1_bit;
sbit LCD_EN at RE2_bit;
sbit LCD_D4 at RD4_bit;
sbit LCD_D5 at RD5_bit;
sbit LCD_D6 at RD6_bit;
sbit LCD_D7 at RD7_bit;

sbit LCD_RS_Direction at TRISE1_bit;
sbit LCD_EN_Direction at TRISE2_bit;
sbit LCD_D4_Direction at TRISD4_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D7_Direction at TRISD7_bit;

sbit sfr PushButton at RE0_bit;
sbit sfr PushButton_Direction at TRISE0_bit;


float freq=88.0;
char x=0;
unsigned int read;
char counter=0;
float fraction;
char Buffer[50];


void main() {
  ADCON1=0x0e;
  porta=0;
  trisa=0x01;
  PushButton=0;
  PushButton_Direction=1;;
  FM_INIT(88.0);
  FM_DISABLE();
  Lcd_Init();
  Lcd_Cmd(_LCD_CURSOR_OFF);
  lcd_out(1,1,"frequency");

  
  while (1) 
  {
    lcd_out(1,1,"frequency");
    FloatToStr(freq,Buffer);
    Lcd_Out(2,1,Buffer);
    delay_ms(100);
    Lcd_Cmd(_LCD_CLEAR);
    if(PushButton)
    {
    while(PushButton){counter++;delay_ms(100);}
    if(counter>5)
    {
      counter=10;
      FM_DISABLE();
      lcd_out(1,1,"set in 2 sec");
      delay_ms(2000);
      while(1)
      {
        lcd_out(1,1,"set frequency");
        read=adc_read(0);
        freq=read*108.0/1024.0;
        freq=(unsigned int)freq;
        Lcd_Out(2,1,ConvertInt2String(freq));
        delay_ms(100);
        Lcd_cmd(_LCD_CLEAR);
        if(PushButton){delay_ms(100);break;}
      }
      lcd_out(1,1,"set in 2 sec");
      delay_ms(2000);
      while(1)
      {
        read=ADC_Read(0);
        if(read>=0&&read<102)fraction=(float)0.0;
        else if(read>=102&&read<204)fraction=(float)0.1;
        else if(read>=204&&read<306)fraction=(float)0.2;
        else if(read>=306&&read<408)fraction=(float)0.3;
        else if(read>=408&&read<510)fraction=(float)0.4;
        else if(read>=510&&read<612)fraction=(float)0.5;
        else if(read>=612&&read<714)fraction=(float)0.6;
        else if(read>=714&&read<816)fraction=(float)0.7;
        else if(read>=816&&read<918)fraction=(float)0.8;
        else if(read>=918&&read<1023)fraction=(float)0.9;
        else ;
        lcd_out(1,1,"set fraction");
        FloatToStr(fraction,Buffer);
        Lcd_Out(2,1,Buffer);
        delay_ms(100);
        Lcd_cmd(_LCD_CLEAR);
        if(PushButton){delay_ms(100);break;}
      }
      freq=freq+fraction;
      FM_SET_FREQUENCY(freq);
    }
    
    
    if(counter<5)
    {
      counter=0;
      x=!x;
      if(x){FM_ENABLE();Lcd_Cmd(_LCD_CLEAR);Lcd_Out_cp("ON AIR");}
      else {FM_DISABLE();Lcd_Cmd(_LCD_CLEAR);Lcd_Out_cp("OFF AIR");}
      delay_ms(2000);
    }
    if(counter==10){counter=0;}
    }



  }
}